# Missing Revoke Method on JWT

## Overview

* **Rule ID**: `javascript_express_jwt_not_revoked`
* **Applicable Languages**: Javascript
* **Weakness ID**: CWE-693

## Description

Failing to implement a revoke method for JSON Web Tokens (JWTs) can lead to security vulnerabilities, especially when the tokens contain sensitive information. To maintain the integrity and confidentiality of data contained within JWTs, it is best practice to have a caching policy that always includes a revoke mechanism.

## Remediation Guidelines

* **Do** ensure JWTs are short-lived by implementing a method to revoke them. This reduces the risk of unauthorized access to sensitive information.

  ```javascript
  expressjwt({
    ...
    isRevoked: this.customRevokeCall(),
    ...
  })

  ```

## References

* [**ExpressJWT documentation on revoking tokens**](https://github.com/auth0/express-jwt#revoked-tokens)
* [**CWE-693: Protection Mechanism Failure**](https://cwe.mitre.org/data/definitions/693.html)

## Configuration

To omit this rule during a scan, and to provide you with continuous 24/7 code-level scanning, you can employ our [**SAST TOOL**](https://scopy.sec1.io/login)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.sec1.io/user-docs/4-sast/3-javascript/missing-revoke-method-on-jwt.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
